Project Chrono: chrono::vehicle::TrackShoeBandANCF Class Reference

Public Member Functions | List of all members
chrono::vehicle::TrackShoeBandANCF Class Reference
VEHICLE module » Tracked vehicles » Track-shoe subsystem

## Description

Band-ANCF track shoe with central guide constructed with data from file (JSON format).

`#include <TrackShoeBandANCF.h>`

Inheritance diagram for chrono::vehicle::TrackShoeBandANCF:
[legend]
Collaboration diagram for chrono::vehicle::TrackShoeBandANCF:
[legend]

## Public Member Functions
| TrackShoeBandANCF (const std::string &filename)
| TrackShoeBandANCF (const rapidjson::Document &d)
virtual GuidePinType | GetType () const final override
| Return the type of track shoe (guiding pin).
virtual double | GetHeight () const override
| Return the height of the track shoe.
virtual double | GetTreadMass () const override
| Return the mass of the tread body.
virtual double | GetWebMass () const override
| Return the mass of the web.
virtual const ChVector3d & | GetTreadInertia () const override
| Return the moments of inertia of the tread body.
virtual const ChVector3d & | GetWebInertia () const override
| Return the moments of inertia of the web.
virtual const ChVector3d & | GetGuideBoxDimensions () const override
| Return the dimensions of the contact box for the guiding pin.
virtual double | GetGuideBoxOffsetX () const override
| Return the offset (in X direction) of the guiding pin.
virtual double | GetBeltWidth () const override
| Return belt geometry parameters.
virtual double | GetToothTipLength () const override
| Return the length of the flat tip of the tread tooth tip (in the X direction).
virtual double | GetToothBaseLength () const override
| Return the length of the base of the tread tooth (in the X direction) where the tooth circular profile ends.
virtual double | GetToothWidth () const override
| Return the width of the one of the tooth profile sections of the tread tooth (in the Y direction).
virtual double | GetToothHeight () const override
| Return the height from the base to the tip of the tread tooth profile (in the Z direction).
virtual double | GetToothArcRadius () const override
| Return the radius of the tooth profile arc that connects the tooth tip and base lines.
virtual double | GetWebLength () const override
| Return the combined length of all of the web sections (in the X direction).
virtual double | GetWebThickness () const override
| Return the thickness of the web section (in the Z direction).
virtual unsigned int | GetNumElementsLength () const override
| Get the number of shell elements across the web length (from tread body to tread body).
virtual unsigned int | GetNumElementsWidth () const override
| Get the number of shell elements across the web width (side to side).
virtual double | GetSteelLayerThickness () const override
| Get thickness of the inner steel layer.
virtual double | GetTreadLength () const override
| Return the length of the tread below the web area (in the X direction, tread pad for ground contact).
virtual double | GetTreadThickness () const override
| Return the thickness of the tread below the web area (tread pad for ground contact).
virtual const std::string & | GetTreadVisualizationMeshName () const override
| Specify the name assigned to the procedurally-generated tread body visualization mesh.
Public Member Functions inherited from chrono::vehicle::ChTrackShoeBandANCF
| ChTrackShoeBandANCF (const std::string &name, ElementType element_type=ElementType::ANCF_4, bool constrain_curvature=false)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual ChVector3d | GetTension () const override
| Get track tension at this track shoe.
virtual void | Initialize (std::shared_ptr< ChBodyAuxRef > chassis, const ChVector3d &location, const ChQuaternion<> &rotation) override
| Initialize this track shoe subsystem.
virtual void | RemoveVisualizationAssets () override final
| Remove visualization assets for the track shoe subsystem.
Public Member Functions inherited from chrono::vehicle::ChTrackShoeBand
| ChTrackShoeBand (const std::string &name)
virtual double | GetPitch () const override
| Return the pitch length of the track shoe.
void | WriteTreadVisualizationMesh (const std::string &out_dir)
| Write the procedurally-generated tread body visualization mesh to a Wavefront OBJ file.
void | ExportTreadVisualizationMeshPovray (const std::string &out_dir)
| Export the procedurally-generated tread body visualization mesh as a macro in a PovRay include file.
Public Member Functions inherited from chrono::vehicle::ChTrackShoe
size_t | GetIndex () const
| Get the index of this track shoe within its containing track assembly.
std::shared_ptr< ChBody > | GetShoeBody () const
| Get the shoe body.
virtual ChVehicleGeometry | GetGroundContactGeometry () const
| Return contact geometry and material for interaction with terrain.
void | EnableCollision (bool val)
| Turn on/off collision flag for the shoe body.
void | SetIndex (size_t index)
| Set the index of this track shoe within its containing track assembly.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Public Types inherited from chrono::vehicle::ChTrackShoeBandANCF
enum class | ElementType { ANCF_4 , ANCF_8 }
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChTrackShoeBandANCF
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
Protected Member Functions inherited from chrono::vehicle::ChTrackShoeBand
virtual ChVector3d | GetLateralContactPoint () const override
| Return the location of the guiding pin center, expressed in the shoe reference frame.
void | AddShoeContact (ChContactMethod contact_method)
| Add contact geometry for the tread body.
void | AddShoeVisualization ()
| Add visualization of the tread body, based on primitives corresponding to the contact shapes.
Protected Member Functions inherited from chrono::vehicle::ChTrackShoe
| ChTrackShoe (const std::string &name)
| Construct a track shoe subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChTrackShoeBand
static ChColor | GetColor (size_t index)
| Get index-specific color (for visualization).
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChTrackShoeBand
ChContactMaterialData | m_tooth_matinfo
| data for contact material for teeth (sprocket interaction)
ChContactMaterialData | m_body_matinfo
| date for contact material for main body (wheel interaction)
ChContactMaterialData | m_pad_matinfo
| data for contact material for pad (ground interaction)
ChContactMaterialData | m_guide_matinfo
| date for contact material for guide pin (wheel interaction)
Protected Attributes inherited from chrono::vehicle::ChTrackShoe
size_t | m_index
| index of this track shoe within its containing track assembly
std::shared_ptr< ChBody > | m_shoe
| handle to the shoe body
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetBeltWidth()

virtual double chrono::vehicle::TrackShoeBandANCF::GetBeltWidth | ( |  | ) | const
| inlineoverridevirtual

Return belt geometry parameters.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetGuideBoxDimensions()

virtual const ChVector3d & chrono::vehicle::TrackShoeBandANCF::GetGuideBoxDimensions | ( |  | ) | const
| inlineoverridevirtual

Return the dimensions of the contact box for the guiding pin.

Note that this is for contact with wheels, idler, and ground only. This contact geometry does not affect contact with the sprocket.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetGuideBoxOffsetX()

virtual double chrono::vehicle::TrackShoeBandANCF::GetGuideBoxOffsetX | ( |  | ) | const
| inlineoverridevirtual

Return the offset (in X direction) of the guiding pin.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetHeight()

virtual double chrono::vehicle::TrackShoeBandANCF::GetHeight | ( |  | ) | const
| inlineoverridevirtual

Return the height of the track shoe.

Implements chrono::vehicle::ChTrackShoe.

## ◆ GetNumElementsLength()

virtual unsigned int chrono::vehicle::TrackShoeBandANCF::GetNumElementsLength | ( |  | ) | const
| inlineoverridevirtual

Get the number of shell elements across the web length (from tread body to tread body).

Implements chrono::vehicle::ChTrackShoeBandANCF.

## ◆ GetNumElementsWidth()

virtual unsigned int chrono::vehicle::TrackShoeBandANCF::GetNumElementsWidth | ( |  | ) | const
| inlineoverridevirtual

Get the number of shell elements across the web width (side to side).

Implements chrono::vehicle::ChTrackShoeBandANCF.

## ◆ GetSteelLayerThickness()

virtual double chrono::vehicle::TrackShoeBandANCF::GetSteelLayerThickness | ( |  | ) | const
| inlineoverridevirtual

Get thickness of the inner steel layer.

The rubber layer thicknesses are obtained from the total web thickness.

Implements chrono::vehicle::ChTrackShoeBandANCF.

## ◆ GetToothArcRadius()

virtual double chrono::vehicle::TrackShoeBandANCF::GetToothArcRadius | ( |  | ) | const
| inlineoverridevirtual

Return the radius of the tooth profile arc that connects the tooth tip and base lines.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetToothBaseLength()

virtual double chrono::vehicle::TrackShoeBandANCF::GetToothBaseLength | ( |  | ) | const
| inlineoverridevirtual

Return the length of the base of the tread tooth (in the X direction) where the tooth circular profile ends.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetToothHeight()

virtual double chrono::vehicle::TrackShoeBandANCF::GetToothHeight | ( |  | ) | const
| inlineoverridevirtual

Return the height from the base to the tip of the tread tooth profile (in the Z direction).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetToothTipLength()

virtual double chrono::vehicle::TrackShoeBandANCF::GetToothTipLength | ( |  | ) | const
| inlineoverridevirtual

Return the length of the flat tip of the tread tooth tip (in the X direction).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetToothWidth()

virtual double chrono::vehicle::TrackShoeBandANCF::GetToothWidth | ( |  | ) | const
| inlineoverridevirtual

Return the width of the one of the tooth profile sections of the tread tooth (in the Y direction).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetTreadInertia()

virtual const ChVector3d & chrono::vehicle::TrackShoeBandANCF::GetTreadInertia | ( |  | ) | const
| inlineoverridevirtual

Return the moments of inertia of the tread body.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetTreadLength()

virtual double chrono::vehicle::TrackShoeBandANCF::GetTreadLength | ( |  | ) | const
| inlineoverridevirtual

Return the length of the tread below the web area (in the X direction, tread pad for ground contact).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetTreadMass()

virtual double chrono::vehicle::TrackShoeBandANCF::GetTreadMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the tread body.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetTreadThickness()

virtual double chrono::vehicle::TrackShoeBandANCF::GetTreadThickness | ( |  | ) | const
| inlineoverridevirtual

Return the thickness of the tread below the web area (tread pad for ground contact).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetTreadVisualizationMeshName()

virtual const std::string & chrono::vehicle::TrackShoeBandANCF::GetTreadVisualizationMeshName | ( |  | ) | const
| inlineoverridevirtual

Specify the name assigned to the procedurally-generated tread body visualization mesh.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetType()

virtual GuidePinType chrono::vehicle::TrackShoeBandANCF::GetType | ( |  | ) | const
| inlinefinaloverridevirtual

Return the type of track shoe (guiding pin).

A derived class must specify the type of track shoe (which must be consistent with the idler and road wheels in the containing track assembly.

Implements chrono::vehicle::ChTrackShoe.

## ◆ GetWebInertia()

virtual const ChVector3d & chrono::vehicle::TrackShoeBandANCF::GetWebInertia | ( |  | ) | const
| inlineoverridevirtual

Return the moments of inertia of the web.

These will be distributed over the specified number of web segments.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetWebLength()

virtual double chrono::vehicle::TrackShoeBandANCF::GetWebLength | ( |  | ) | const
| inlineoverridevirtual

Return the combined length of all of the web sections (in the X direction).

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetWebMass()

virtual double chrono::vehicle::TrackShoeBandANCF::GetWebMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the web.

This will be equally distributed over the specified number of web segments.

Implements chrono::vehicle::ChTrackShoeBand.

## ◆ GetWebThickness()

virtual double chrono::vehicle::TrackShoeBandANCF::GetWebThickness | ( |  | ) | const
| inlineoverridevirtual

Return the thickness of the web section (in the Z direction).

Implements chrono::vehicle::ChTrackShoeBand.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_shoe/TrackShoeBandANCF.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_shoe/TrackShoeBandANCF.cpp